<?php

	//
	//	This file is part of MythWeb,
	//	a php-based interface into MythTV.
	//
	//	(c) 2002 by Thor Sigvaldason and Isaac Richards
	//	MythWeb is distributed under the
	//	GNU GENERAL PUBLIC LICENSE version 2
	//	(see http://www.gnu.org)
	//

	
//
//	This file contains a few handy functions
//


//
//	Print a quote (up on the banner)
//

function printQuote($theQuote, $theAuthor, $fontface, $fontsize, $fontcolor)
{

	print("\t\t\t\t\t<TABLE>\n");
	print("\t\t\t\t\t\t<TR>\n");
	print("\t\t\t\t\t\t\t<TD>\n");
	print("\t\t\t\t\t\t\t\t<FONT FACE=\"$fontface\" SIZE=\"+1\" COLOR=\"$fontcolour\">\"<I>$theQuote\"</I></FONT>\n");
	print("\t\t\t\t\t\t\t</TD>\n");
	print("\t\t\t\t\t\t</TR>\n");
	print("\t\t\t\t\t\t<TR>\n");
	print("\t\t\t\t\t\t\t<TD ALIGN=\"RIGHT\">\n");
	print("\t\t\t\t\t\t\t\t<FONT FACE=\"$fontface\" SIZE=\"$fontsize\" COLOR=\"$fontcolour\">$theAuthor</FONT>\n");
	print("\t\t\t\t\t\t\t</TD>\n");
	print("\t\t\t\t\t\t</TR>\n");
	print("\t\t\t\t\t</TABLE>\n");
	
}

//
//	Print the date with any offset included
//

function printTheDate($time, $offset, $numbSlots)
{
	$adjuster = round(30 * $numbSlots * $offset);
	$theYear = substr($time, 0, 4);
	$theMonth = substr($time, 4, 2); 
	$theDay = substr($time, 6, 2);
	$theHour = substr($time, 8, 2);
	$theMinute = substr($time, 10, 2);
	
	$soTheDateMustBe = date("l (F j)", mktime($theHour, $theMinute + adjuster, 0, $theMonth, $theDay, $theYear)); 
	print("$soTheDateMustBe");
}

//
//	Given a program name, set the MySQL MythTV database
//	to record that program whenever it's shown, or 
//	whenever it is shown on the supplied channel.
//
function recordAlways($programName, $theChannel)
{
	if(strlen($programName) > 0) // Are there program names as short as one character?
	{

    		// Check if this is record Always on a channel ie type = 3
		if ($theChannel) 
		{
		    //
		    //	Check to see if type = 3 is already in the database for this program and title,
		    //  if it is we will do nothing.  If it isn't then all other types will be deleted
		    //  and a type 3 record added.
		    //		
		    $alreadyThereQuery = mysql_query("select title from record where type = 3 and title = \"$programName\" and chanid = \"$theChannel\"");
		    if(mysql_num_rows($alreadyThereQuery) < 1)
		    {
			//
			//	This program name is not in the record table as a type = 3,
			//	so we need to add it
			// 
			mysql_query("delete from record where type = 4 and title = \"$programName\"");
			mysql_query("delete from record where type = 1 and title = \"$programName\" and chanid = \"$theChannel\"");
			mysql_query("delete from record where type = 2 and title = \"$programName\" and chanid = \"$theChannel\"");
			mysql_query("insert into record (type,title,chanid) values (3,\"$programName\",\"$theChannel\")");

			//
    			//	Tell mythfrontend that something has changed
			//
			$alreadyThere = mysql_query("select value from settings where value = \"RecordChanged\"");
			if(mysql_num_rows($alreadyThere) < 1)
			{
			    mysql_query("insert into settings (value,data) values (\"RecordChanged\",\"yes\")");
			}
			else
			{
			    mysql_query("update settings set data = \"yes\" where value = \"RecordChanged\"");
			}

		    }
		}
		else 
		{
			
		    //
		    //	Check to see if type = 4 is already in the database for this program,
		    //  if it is we will do nothing.  If it isn't then all other types will be deleted
		    //  and a type 4 record added.
		    //		
		    $alreadyThereQuery = mysql_query("select title from record where type = 4 and title = \"$programName\"");
		    if(mysql_num_rows($alreadyThereQuery) < 1)
		    {
			//
			//	This program name is not in the record table as a type = 4,
			//	so we need to add it
			//				
			mysql_query("delete from record where type = 3 and title = \"$programName\"");
			mysql_query("delete from record where type = 1 and title = \"$programName\"");
			mysql_query("delete from record where type = 2 and title = \"$programName\"");
			mysql_query("insert into record (type,title) values (4,\"$programName\")");
		    
			//
    			//		Tell mythfrontend that something has changed
			//
			$alreadyThere = mysql_query("select value from settings where value = \"RecordChanged\"");
			if(mysql_num_rows($alreadyThere) < 1)
			{
			    mysql_query("insert into settings (value,data) values (\"RecordChanged\",\"yes\")");
			}
			else
			{
			    mysql_query("update settings set data = \"yes\" where value = \"RecordChanged\"");
			}

		    }

		}
	}
}



//
//	Given a starting time and channel number, set the
//	database to record that program once
//

function recordOnce($channel, $start)
{
	//
	//	Because we only have the channel number and starting time,
	//	We need to look up the rest of the information
	//
	
	$aQuery = mysql_query("select chanid, starttime, endtime, title, subtitle, description from program where chanid = $channel and starttime = $start ");
	if($theRow = mysql_fetch_row($aQuery))
	{
		//
		//	It exists, so delete all references 
		//	and then create a singlerecord entry
		//
		dontRecord($theRow[3], $theRow[0], $theRow[1]);
		$anotherQuery = mysql_query("insert into record (type, chanid, starttime, startdate,  endtime, enddate, title, subtitle, description) values (1, $theRow[0],SEC_TO_TIME(TIME_TO_SEC(\"$theRow[1]\")),FROM_DAYS(TO_DAYS(\"$theRow[1]\")),SEC_TO_TIME(TIME_TO_SEC(\"$theRow[2]\")),FROM_DAYS(TO_DAYS(\"$theRow[2]\")), \"$theRow[3]\", \"$theRow[4]\", \"$theRow[5]\")");
		//
		//	Tell mythfrontend that something has changed
		//
		$alreadyThere = mysql_query("select value from settings where value = \"RecordChanged\"");
		if(mysql_num_rows($alreadyThere) < 1)
		{
		    mysql_query("insert into settings (value,data) values (\"RecordChanged\",\"yes\")");
		}
		else
		{
		    mysql_query("update settings set data = \"yes\" where value = \"RecordChanged\"");
		}
	}
	
}

//
//	Given a channel, a starting time, an ending time
//	and a title, record a program every day in that slot 
//

function recordTimeslot($channel, $start, $end, $title)
{
	//
	//	Delete all recording settings relevant to this
	//	program and then set timeslotrecord
	//
	dontRecord($title, $channel, $start);
	$aQuery = mysql_query("insert into record (type, chanid, starttime, endtime, title) values (2, $channel, \"$start\", \"$end\", \"$title\")");
	//
	//	Tell mythfrontend that something has changed
	//
	$alreadyThere = mysql_query("select value from settings where value = \"RecordChanged\"");
	if(mysql_num_rows($alreadyThere) < 1)
	{
	    mysql_query("insert into settings (value,data) values (\"RecordChanged\",\"yes\")");
	}
	else
	{
	    mysql_query("update settings set data = \"yes\" where value = \"RecordChanged\"");
	}
}

//
//	Given a name, a channel number, and a starting time
//	make sure I neither "always record" this program
//	nor "record once" the program nor "timeslot record" it
//

function dontRecord($programName, $channel, $start)
{
	$dQuery = mysql_query("delete from record where type = 4 and title = \"$programName\"");
	$aQuery = mysql_query("delete from record where type = 3 and chanid = $channel and title = \"$programName\"");
	$bQuery = mysql_query("delete from record where type = 1 and chanid = $channel and starttime = \"$start\"");
	$cQuery = mysql_query("delete from record where type = 2 and chanid = $channel and starttime = \"$start\" and title = \"$programName\"");
	//
	//	Tell mythfrontend that something has changed
	//
	$alreadyThere = mysql_query("select value from settings where value = \"RecordChanged\"");
	if(mysql_num_rows($alreadyThere) < 1)
	{
	    mysql_query("insert into settings (value,data) values (\"RecordChanged\",\"yes\")");
	}
	else
	{
	    mysql_query("update settings set data = \"yes\" where value = \"RecordChanged\"");
	}
}

//
//	Boolean check to see if a given title is in 
//	the allrecord table
//

function isInAlwaysRecord($theTitle)
{
	$aQuery = mysql_query("select * from record where title = \"$theTitle\" and type = 4");
	if(mysql_num_rows($aQuery) > 0)
	{
		return(TRUE);
	}
	return(FALSE);
}

//
//	Boolean check to see if a given title
//	is set to always record on a certain channel
//

function isInChannelAlwaysRecord($theChannel, $theTitle)
{
	$aQuery = mysql_query("select * from record where title = \"$theTitle\" and chanid = \"$theChannel\" and type = 3 ");
	if(mysql_num_rows($aQuery) > 0)
	{
		return(TRUE);
	}
	return(FALSE);
}

//
//	Boolean check to see if a given title is in 
//	the timeslotrecord table
//

function isInTimeslotRecord($theChannel, $theStart, $theEnd, $theTitle)
{
	$aQuery = mysql_query("select * from record where type = 2 and chanid = \"$theChannel\" and starttime = \"$theStart\" and endtime = \"$theEnd\" and title = \"$theTitle\"");
	if(mysql_num_rows($aQuery) > 0)
	{
		return(TRUE);
	}
	return(FALSE);
}
//
//	Boolean check to see if a given title is in 
//	the once record table
//

function isInOnceRecord($theChannel, $theStart)
{
	$aQuery = mysql_query("select * from record where type = 1 and chanid = \"$theChannel\" and starttime = SEC_TO_TIME(TIME_TO_SEC(\"$theStart\")) and startdate = FROM_DAYS(TO_DAYS(\"$theStart\"))" );
	if(mysql_num_rows($aQuery) > 0)
	{
		return(TRUE);
	}
	return(FALSE);
}

//
//	Make a decent guess about whether this is a movie
//	or not
//
function smellsLikeMovie($length, $type)
{
	if($length > 70)
	{
		if(	$type == "Drama" ||
			$type == "Doc" ||
			$type == "Mystery" ||
			$type == "Musical" ||
			$type == "Action" ||
			$type == "Comedy" ||
			$type == "War" ||
			$type == "Romance" ||
			$type == "Crime" ||
			$type == "SciFi" ||
			$type == "Horror")
		{
			return(TRUE);
		}
	}
	return(FALSE);
}


//
//	Build an array of time slots based on the
//	starting time and the number of slots desired
//
function setupTimes ($starttime, $numbSlots)
{
	$currenttime = $starttime;

	for ($i = 0; $i < $numbSlots; $i += 1)
	{
		$mytime = new TimeValue;
 		$mytime->setVals($currenttime);
 		$timearray[$i]=$mytime;
		$currenttime = date('YmdHis', ($mytime->unixtime + 1800));
	}
 	return $timearray;
}


//
//	Build an array that contains info about
//	recordings.
//
function setupRecordings()
{
	$theQuery = "select record.*,channel.channum from record,channel where channel.chanid = record.chanid and record.type = 1 order by record.startdate, record.starttime asc;";
	$recordQuery = mysql_query($theQuery) or die("Uh oh, I couldn't open the record table");;
	$i = 0;
	while($recordTuple = mysql_fetch_array($recordQuery, MYSQL_ASSOC))
	{
		$aRecord = new Recording;
		$aRecord->chanid = $recordTuple["chanid"];
		$aRecord->channum = $recordTuple["channum"];
		$aRecord->startdate = $recordTuple["startdate"];
		$aRecord->starttime = $recordTuple["starttime"];
		$aRecord->enddate = $recordTuple["enddate"];
		$aRecord->endtime = $recordTuple["endtime"];
		$aRecord->title = $recordTuple["title"];
		$aRecord->subtitle = $recordTuple["subtitle"];
		$aRecord->description = $recordTuple["description"];
		$recordArray[$i] = $aRecord;
		$i += 1;
	}
	mysql_free_result($recordQuery);
	return $recordArray;
}

//
//	Populate info about channels
//
function setupChannels ()
{
	$chanquery = "SELECT * FROM channel ORDER BY channum + 0";

	$chanresult = mysql_query($chanquery) or die("Eeek. I couldn't open the channel table in the mythconverg database.");
   
	$i = 0;

	while ($chanline = mysql_fetch_array($chanresult, MYSQL_ASSOC))
	{
	    $mychan = new Channel;
	    $mychan->chanid = $chanline["chanid"];
	    $mychan->channum = $chanline["channum"];
	    $mychan->callsign = $chanline["callsign"];
	    $mychan->icon = $chanline["icon"];   
	    $mychan->repathIcon();

	    $channelarray[$i] = $mychan;
	    $i += 1;
	}

	mysql_free_result($chanresult);
	return $channelarray;
}

function singleSelect($query)
{
	$result = mysql_query($query) or die("Error in simpleSelect('$query').");
	$data = mysql_fetch_array($result, MYSQL_ASSOC);
	mysql_free_result($result);
	return $data;
}

//
//	So, anything good on TV?
//
function setupPrograms ($channelarray, $timearray, $numbSlots)
{
	$maxStars = $GLOBALS['maximumStarRating'];
	$star = $GLOBALS['starRatingCharacter'];

	$rec = singleSelect("select count(*) as 'recordings' from record;");
	if ((int) $rec['recordings'] > 0)
	{
		$recordFrom = ", record ";
		$recordSelect =	"sum(record.type = 4 and program.title = record.title)>0 as 'type4', ".
			"sum(record.type = 3 and program.title = record.title and record.chanid = program.chanid)>0 as 'type3', ".
			"sum(record.type = 2 and program.title = record.title and record.chanid = program.chanid and ".
			"     record.starttime = sec_to_time(time_to_sec(program.starttime)) and ".
			"     record.endtime = sec_to_time(time_to_sec(program.endtime)))>0 as 'type2', " .
			"sum(record.type = 1 and program.title = record.title and record.chanid = program.chanid and ".
			"     record.starttime = sec_to_time(time_to_sec(program.starttime)) and ".
			"     record.startdate = from_days(to_days(program.starttime)))>0 as 'type1', ";
	}
	else
	{
		$recordFrom = "";
		$recordSelect = "";
	}

	for ($i = 0; $i < $numbSlots; $i += 1)
	{
		$channelindex = 0;
		$mytime = $timearray[$i];

		$query = "SELECT ".$recordSelect.
			"channel.chanid, ".
			"channel.channum, ".
			"program.starttime, ".
			"program.endtime, ".
			"program.title, ".
			"program.subtitle, ".
			"program.description, ".
			"program.category, ".
			"program.airdate, ".
			"program.stars, ".
			"concat(repeat('$star', program.stars*$maxStars), if((program.stars*$maxStars*10) % 10, '&frac12;', '')) as starstring, ".
			"ifnull(programrating.system, '') as rater, ".
			"ifnull(programrating.rating, '') as rating, ".
			"((UNIX_TIMESTAMP(program.endtime) - UNIX_TIMESTAMP(program.starttime)) / 60 ) as duration ".
			"FROM channel left join program using (chanid) left join programrating using (chanid, starttime) ".$recordFrom.
			"WHERE program.starttime < " . $mytime->sqltime . " AND program.endtime > " . $mytime->sqltime." ".
			"GROUP BY program.chanid ORDER BY channel.channum + 0, programrating.system;";

		$result = mysql_query($query) or die("Gadzooks! I can't open the program table.  " . $query);

		while ($line = mysql_fetch_array($result, MYSQL_ASSOC))
		{
			while ($line["channum"] != $channelarray[$channelindex]->channum)
			{
				$programarray[$channelindex][$i] = null;
				$channelindex++;
			}
			$myprog = new ProgramInfo;
			$myprog->title = $line["title"];
			$myprog->subtitle = $line["subtitle"];
			$myprog->chanid = $line["chanid"];
			$myprog->chanstr = $line["channum"];
			$myprog->startts = $line["starttime"];
			$myprog->endts = $line["endtime"];
			$myprog->progType = $line["category"];
			$myprog->duration = $line["duration"];
			$myprog->description = $line["description"];
			$myprog->rater = $line["rater"];
			$myprog->rating = $line["rating"];
			$myprog->airdate = $line["airdate"];
			$myprog->stars = $line["stars"];
			$myprog->starstring = $line["starstring"];

			$myprog->whenRecord += $line["type1"]<<1;
			$myprog->whenRecord += $line["type2"]<<2;
			$myprog->whenRecord += $line["type3"]<<3;
			$myprog->whenRecord += $line["type4"]<<4;

			$programarray[$channelindex][$i] = $myprog;

			$channelindex++;
		}

		mysql_free_result($result);
	}
	return $programarray;
}

// fetch all the movie listings for N days in the future
function fetchMovieListings($ppv_channels, $day)
{
	$maxStars = $GLOBALS['maximumStarRating'];
	$star = $GLOBALS['starRatingCharacter'];

	if (count($ppv_channels) > 0)
	{
		foreach ($ppv_channels as $hostname => $capturecards)
		{
			foreach ($capturecards as $card => $input)
			{
				foreach ($input as $inputname => $channels)
				{
					$source = singleSelect("select ".
								"capturecard.videodevice, ".
								"cardinput.inputname, ".
								"cardinput.sourceid as 'id' ".
							"from capturecard left join cardinput using (cardid) ".
							"where capturecard.videodevice = \"$card\" and ".
								"cardinput.inputname = \"$inputname\" and ".
								"capturecard.hostname = \"$hostname\";");
					foreach ($channels as $start => $stop)
					{
						$ignore .= "and ";
						if ((int) $start && (int) $stop)
						{
							$ignore .= "(channel.sourceid != ".$source['id'].
							" or channel.channum not between $start and $stop) ";
						}
						else
						{
							$ignore .= "(channel.sourceid != ".$source['id'].
							" or channel.channum not in (\"$start\", \"$stop\")) ";
						}
					}
				}
			}
		}
	}

	$query = "SELECT ".
			"sum(record.type = 4)>0 as 'type4', ".
			"sum(record.type = 3 and record.chanid = program.chanid)>0 as 'type3', ".
			"sum(record.type = 2 and record.chanid = program.chanid and ".
			"     record.starttime = sec_to_time(time_to_sec(program.starttime)) and ".
			"     record.endtime = sec_to_time(time_to_sec(program.endtime)))>0 as 'type2', " .
			"sum(record.type = 1 and record.chanid = program.chanid and ".
			"     record.starttime = sec_to_time(time_to_sec(program.starttime)) and ".
			"     record.startdate = from_days(to_days(program.starttime)))>0 as 'type1', ".
			"channel.chanid, ".
			"channel.channum, ".
			"channel.callsign, ".
			"channel.icon, ".
			"program.starttime, ".
			"program.starttime, ".
			"program.endtime, ".
			"program.title, ".
			"program.subtitle, ".
			"program.description, ".
			"program.category, ".
			"program.airdate, ".
			"program.stars, ".
			"concat(repeat('$star', program.stars*$maxStars), if((program.stars*$maxStars*10) % 10, '&frac12;', '')) as starstring, ".
			"ifnull(programrating.system, '') as rater, ".
			"ifnull(programrating.rating, '') as rating, ".
			"((UNIX_TIMESTAMP(program.endtime) - UNIX_TIMESTAMP(program.starttime)) / 60) as duration ".
		"FROM programrating left join program using (chanid, starttime) left join record using (title), channel ".
		"WHERE programrating.starttime between if($day, date_add(curdate(), interval $day day), now()) ".
			                        "and date_add(curdate(), interval $day+1 day) ".
			"AND program.chanid = channel.chanid ".
			"AND (UNIX_TIMESTAMP(program.endtime) - UNIX_TIMESTAMP(program.starttime)) / 60 > 70 ".
			"AND program.stars > 0 AND program.airdate > 0 ".
			$ignore.
		"GROUP BY programrating.chanid, programrating.starttime ".
		"ORDER BY programrating.starttime ASC, programrating.system ASC;";

	$result = mysql_query($query) or die("Gadzooks! I can't open the program table.");

	for ($i = 0; $line = mysql_fetch_array($result, MYSQL_ASSOC); $i++)
	{
		$myprog = new ProgramInfo;
		$myprog->title = $line["title"];
		$myprog->subtitle = $line["subtitle"];
		$myprog->chanid = $line["chanid"];
		$myprog->chanstr = $line["channum"];
		$myprog->startts = $line["starttime"];
		$myprog->endts = $line["endtime"];
		$myprog->progType = $line["category"];
		$myprog->duration = $line["duration"];
		$myprog->description = $line["description"];
		$myprog->rater = $line["rater"];
		$myprog->rating = $line["rating"];
		$myprog->airdate = $line["airdate"];
		$myprog->stars = $line["stars"];
		$myprog->starstring = $line["starstring"];
		$myprog->callsign = $line["callsign"];
		$myprog->icon = $line["icon"];

		$myprog->whenRecord += $line["type1"]<<1;
		$myprog->whenRecord += $line["type2"]<<2;
		$myprog->whenRecord += $line["type3"]<<3;
		$myprog->whenRecord += $line["type4"]<<4;
 
		$listingarray[$i] = $myprog;
	}
   
	mysql_free_result($result);
    
	return $listingarray;
}

// Functions added by Russell Hatch

// gather info from the allrecord table
function setupAllRecordings() {
	$theQuery = "select * from record where type = 3 or type = 4 order by title asc;";
	$recordQuery = mysql_query($theQuery) or die("ERROR: Unable to open the allrecord table");
	$i = 0;
	$now = buildMythTime(time());
	while($recordTuple = mysql_fetch_array($recordQuery, MYSQL_ASSOC)) {
		$chanid = 0;
		$aRecord = new Recording;
		$channel = "";
		$aRecord->title = $recordTuple['title'];
		if ($recordTuple['chanid']) { // see if this program is always recorded on a certain channel
			$aRecord->chanid = $recordTuple['chanid'];
			$chanid = $aRecord->chanid;
			$channel = "&& chanid = \"$aRecord->chanid\"";
		}
		$progQuery = mysql_query("select * from program where (title = \"$aRecord->title\" && starttime > \"$now\" $channel) order by starttime;") or die("ERROR: Unable to open the allrecord table");
		if ($progInfo = mysql_fetch_array($progQuery, MYSQL_ASSOC)) {
			$aRecord->starttime = $progInfo["starttime"];
			$aRecord->endtime = $progInfo["endtime"];
			$chanid = $progInfo["chanid"];
			$aRecord->subtitle = $progInfo["subtitle"];
			$aRecord->description = $progInfo["description"];
		}
		mysql_free_result($progQuery);
		if ($chanid) {
			$chanQuery = mysql_query("select channum from channel where chanid=\"$chanid\";");
			$aRow = mysql_fetch_row($chanQuery);
			$aRecord->channum = $aRow[0];
			mysql_free_result($chanQuery);
		}
		$recordArray[$i] = $aRecord;
		$i++;
	}
	mysql_free_result($recordQuery);
	return($recordArray);
}

// gather information from the timeslotrecord table
function setupTimeSlotRecordings() {
	$now = buildMythTime(time());
	$theQuery = "select record.*,channel.channum from record,channel where type = 2 and record.chanid=channel.chanid order by title asc;";
	$recordQuery = mysql_query($theQuery) or die("ERROR: Unable to open the record table");;
	$i = 0;
	while($recordTuple = mysql_fetch_array($recordQuery, MYSQL_ASSOC))
	{
		$aRecord = new Recording;
		$aRecord->chanid = $recordTuple["chanid"];
		$aRecord->channum = $recordTuple["channum"];
		$aRecord->starttime = $recordTuple["starttime"];
		$aRecord->endtime = $recordTuple["endtime"];
		$aRecord->title = $recordTuple["title"];
		$mythstart = parseTimeSlotTime($aRecord->starttime);
		$mythstart = $mythstart["hour"] . $mythstart["minute"] . $mythstart["second"];
		$mythend = parseTimeSlotTime($aRecord->endtime);
		$mythend = $mythend["hour"] . $mythend["minute"] . $mythend["second"];
		$progQuery = mysql_query("select * from program where (title = \"$aRecord->title\" && starttime > '$now' && chanid = '$aRecord->chanid') order by starttime") or die("ERROR: Unable to open the allrecord table");
		while ($progInfo = mysql_fetch_array($progQuery, MYSQL_ASSOC)) {
			if (substr($progInfo["starttime"],8) == $mythstart &&
			    substr($progInfo["endtime"],8) == $mythend) {
			$aRecord->startdate = $progInfo["starttime"];
			$aRecord->enddate = $progInfo["endtime"];
			$aRecord->subtitle = $progInfo["subtitle"];
			$aRecord->description = $progInfo["description"];
			break;
			}
		}
		mysql_free_result($progQuery);
		$recordArray[$i] = $aRecord;
		$i++;
	}
	mysql_free_result($recordQuery);
	return $recordArray;
}

// parse the time strings into an array
function parseTime($time) {
	$theTime['year'] = substr($time, 0, 4);
	$theTime['month'] = substr($time, 4, 2); 
	$theTime['day'] = substr($time, 6, 2);
	$theTime['hour'] = substr($time, 8, 2);
	$theTime['minute'] = substr($time, 10, 2);
	$theTime['second'] = substr($time, 12, 2);

	return($theTime);
}

// parse the time strings into an array
function parseTime2($time) {
	$theTime['year'] = substr($time, 0, 4);
	$theTime['month'] = substr($time, 5, 2); 
	$theTime['day'] = substr($time, 8, 2);
	$theTime['hour'] = substr($time, 10, 2);
	$theTime['minute'] = substr($time, 13, 2);
	$theTime['second'] = substr($time, 16, 2);

	return($theTime);
}

// since the timeslotrecord table stores times differently, here is another function to parse it
function parseTimeSlotTime($time) {
	$theTime['hour'] = substr($time, 0, 2);
	$theTime['minute'] = substr($time, 3, 2);
	$theTime['second'] = substr($time, 6, 2);

	return($theTime);
}

// return a nice time string to print
function getTimeString2($time) {
	$theTime = parseTime2($time);
	list ($theHour, $ampm) = getHour($theTime['hour']);
	$returnTime = $theTime['month'] . "/" . $theTime['day'] . "/" . $theTime['year'] . " " . $theHour . ":" . $theTime['minute'] . $ampm;
	return($returnTime);
}

// return a nice time string to print
function getTimeString($time) {
	$theTime = parseTime($time);
	list ($theHour, $ampm) = getHour($theTime['hour']);
	$returnTime = $theTime['month'] . "/" . $theTime['day'] . "/" . $theTime['year'] . " " . $theHour . ":" . $theTime['minute'] . $ampm;
	return($returnTime);
}

// return the time as formatted in mysql database
function buildMythTime($time) {
	$local = localtime($time);
	$returnTime = sprintf("%04d%02d%02d%02d%02d%02d", $local[5]+1900, $local[4]+1, $local[3], $local[2], $local[1], $local[0]);
	return($returnTime);
}

# JS: code to connect to the mythbackend and to delete recordings.

# JS: This command connects to mythBackend and returns the results of a command
# string passed to it, haven't tested UTF8.
function backendCommand($str)
{
    static $fp; # static so we can leave the same connection open

    $host = getSetting("MasterServerIP");
    $port = getSetting("MasterServerPort");

    if(!$host || !$port)
        echo "MasterServerIP or MasterServerPort not found! You man need to check your settings.php file or re-run setup mythtv's setup";

    if (!$fp)
        $fp = fsockopen ($host,  $port, $errno, $errstr, 3);

    if($fp)
    {
        # The format of strings sent to mythbackend is
        # <number of bytes + whitespace to = 8 total bytes><data>
        # this handles sending and receiving that format.
        $request = "" . strlen($str);
        for($i = strlen($request); $i < 8; $i++)
            $request .= " ";

        $request .= $str;

	socket_set_timeout($fp,3);

	// IF we don't get a response in 4 seconds something is wrong.
        fputs ($fp, $request);

        # Easiest way, probably not the fastest
        while(!preg_match("/^(\d+)\s+(\S+)$/", $retstr, $matches))
        {
            $retstr .= fread($fp, 1);

	    //If we failed to read: exit
	    if(!$fp || $counter++>10 || $retstr == "")
		return "";
        }
        $len = $matches[1];
        $str = $matches[2] . fread($fp, $len-1);
        return $str;
    }
}

function backendConnect()
{
    $hostname = chop(`hostname`);
    return (backendCommand("ANN Playback $hostname 0") == "OK");
}

function deleteRecorded($filename)
{
   $sep = '[]:[]';
   if(backendConnect())
   {
        $recs = getBackendRows("QUERY_RECORDINGS Delete");
        foreach ($recs as $key => $row)
        {
            $cmd="DELETE_RECORDING";
            foreach($row as $value)
            {
                if ($value == $filename)
                         $found = true;
                $cmd.=$sep . $value;
            }
            if($found)
            {
                # offset
                $cmd.=$sep . "0";
                backendCommand($cmd);
                break;
            }
        }

   }
}

function getBackendRows($query, $offset=1)
{
   $backend_seperator = '\[\]:\[\]';

   $recs = split($backend_seperator, backendCommand($query));

   # start at 1 because foreach skips [0]
   $r=1; $c=0;
   for($t = $offset; $t< sizeof($recs); $t++)
   {
      if(($c) % 19 == 0 && ($c != 0))  {
         $c=0;$r++;
      } else  {
         #print "[$r][$c] = $recs[$t]<br>\n";
         $newrecs[$r][$c++] = $recs[$t];
      }
   }

   # also keep the offset data if needed.
   for($t = 0; $t< $offset; $t++)
        $newrecs['offset'][$t] = $recs[$t];

   return $newrecs;
}

 
function getSetting($setting, $host="")
{
    global $backend_hostname;
    # If we're passed in a host used that, if we have a settings backend_host
    # use that.
    if($host == "")
    {
        if($backend_hostname != "")
        $extra = " AND hostname = '$backend_hostname'";
    } else {
        $extra = " AND hostname = '$host'";
    }

    $theQuery = "SELECT data FROM settings WHERE value = '$setting' $extra";
    $prefixQuery = mysql_query($theQuery) or die("ERROR: Unable to open the settings table: $theQuery");
    $aRow = mysql_fetch_row($prefixQuery);
    $val = $aRow[0];
    mysql_free_result($prefixQuery);
    return $val;
}

function getCardStatus()
{
    $sep = '[]:[]';
    // Get the current card status(es)
    $inputquery = "SELECT distinct cardid, inputname FROM cardinput ORDER BY cardid";
    $inputresult = mysql_query($inputquery) or die("Couldn't open the channel table in the mythconverg database.");
    while ($inputline = mysql_fetch_array($inputresult, MYSQL_ASSOC))
    {
        $line = $inputline['cardid'];
        $recording = backendCommand("QUERY_RECORDER " . $line . $sep . "IS_RECORDING");
        $idStatus[$line] = $recording;
    }
    mysql_free_result($inputresult);
    return $idStatus;
}

// Adapted from my_filesize (see below)
function my_time($time) {
      $min = 60;          // Minute
      $hr  = 60 * $min;   // Hour
      if($time < $hr) {
         return round($time/$min,1)." mins";
      } else if($time > $hr) {
         return round($time/$hr,1)." hrs";
      } else if($time = $hr) {
         return "1 hr";
      }
}
 
// JS: adapted from php.net: sponger 10-Jun-2002 12:28
function my_filesize($size) {
      // Setup some common file size measurements.
      $kb = 1024;         // Kilobyte
      $mb = 1024 * $kb;   // Megabyte
      $gb = 1024 * $mb;   // Gigabyte
      $tb = 1024 * $gb;   // Terabyte
      /* If it's less than a kb we just return the size, otherwise we keep going until the size is in the appropriate measurement range. */
      if($size < $kb) {
         return $size." B";
      } else if($size < $mb) {
         return round($size/$kb,1)." KB";
      } else if($size < $gb) {
         return round($size/$mb,1)." MB";
      } else if($size < $tb) {
         return round($size/$gb,1)." GB";
      } else {
         return round($size/$tb,1)." TB";
      }
}

// fetch all the listings for a certain channel and day
function fetchChannelDaysListings($chanid, $day)
{
	$i = 0;
	$theTime = parseTime($day);

	$from = date('YmdHis', mktime($theTime['hour'], 00, 00, $theTime['month'], $theTime['day'], $theTime['year']));
	$to = date('YmdHis', mktime(23, 59, 59, $theTime['month'], $theTime['day'], $theTime['year']));

	$query = "SELECT channel.chanid, channel.channum, icon, name, starttime, endtime, title, subtitle, description, category, ((UNIX_TIMESTAMP(endtime) - UNIX_TIMESTAMP(starttime)) / 60 ) as duration FROM program,channel WHERE program.chanid = channel.chanid AND program.chanid = $chanid AND starttime >= $from  AND starttime <= $to ORDER BY starttime ASC;";

	$result = mysql_query($query) or die("Gadzooks! I can't open the program table.");

	while ($line = mysql_fetch_array($result, MYSQL_ASSOC))
	{
		$myprog = new ProgramInfo;
		$myprog->title = $line["title"];
		$myprog->subtitle = $line["subtitle"];
		$myprog->chanid = $line["chanid"];
		$myprog->chanstr = $line["channum"];
		$myprog->startts = $line["starttime"];
		$myprog->endts = $line["endtime"];
		$myprog->progType = $line["category"];
		$myprog->duration = $line["duration"];
		$myprog->description = $line["description"];
		$myprog->channame = $line["name"];

		$listingarray[$i] = $myprog;
		$i++;
	}

	mysql_free_result($result);

	return $listingarray;
}

function getHour($hour)  {
	if ($hour > 12) {
		$hour -= 12;
		$ampm = "pm";
	}
	else if ($hour == 0) {
		$hour = 12;
		$ampm = "am";
	}
	else if ($hour == 12) {
		$ampm = "pm";
	}
	else $ampm = "am";
	return array($hour, $ampm);
}

function getLargeFiles($high,$low) {
	$high_word=(int)$high;
	$low_word=(int)$low;

	$shiftcount=0;
        
        if ($low != "0")  // Don't execute this function on a zero byte file.
        {
 		while ((($high_word != 0) || $low_word <= 0 || $low_word > 1024) && $shiftcount < 6) {
			$high_lowbits = ($high_word & 0x3FF);
			$high_word >>= 10;
    
			$low_lowbits = ($low_word & 0x3FF);
			if ($low_word < 0) {
		      		$low_word = (((($low_word & 0x7FFFFFFF)) >> 1) | 0x40000000) >> 9;
			} else {
				$low_word >>= 10;
			}
			$low_word |= $high_lowbits << 22;
//		    		print ("Low Word is Now " . $low_word . "<BR>");
			$shiftcount++;
		}
        }

	$label=array("B","KB","MB","GB","TB","PB","EB");
  
	$low_word += round(($low_lowbits / 1024),1);
//	  print("Looks like about " . $low_word . " " . $label[$shiftcount]);
	return $low_word . " " . $label[$shiftcount];
}

function getUnixTime($mythtime) {
	return strtotime("$mythtime");
}

function makeActive($chanid,$starttime,$endtime) {
    $theQuery = "SELECT preferchanid,preferstarttime,preferendtime FROM conflictresolutionsingle WHERE dislikechanid='$chanid' AND dislikestarttime='$starttime' AND dislikeendtime='$endtime'";
    $oldConflict = mysql_fetch_row(mysql_query($theQuery));
    $theQuery = "UPDATE conflictresolutionsingle SET preferchanid='$chanid',preferstarttime='$starttime',preferendtime='$endtime',dislikechanid='$oldConflict[0]',dislikestarttime='$oldConflict[1]',dislikeendtime='$oldConflict[2]' WHERE dislikechanid='$chanid' AND dislikestarttime='$starttime' AND dislikeendtime='$endtime'";
    $newConflict = mysql_query($theQuery);
    $theQuery = "UPDATE conflictresolutionsingle SET preferchanid='$chanid',preferstarttime='$starttime',preferendtime='$endtime' WHERE preferchanid='$oldConflict[0]' AND preferstarttime='$oldConflict[1]' AND preferendtime='$oldConflict[2]'";
    $allConflicts = mysql_query($theQuery);
}

function fixConflict($chanid,$starttime,$endtime) {
    backendConnect();
    $recs = getBackendRows("QUERY_GETALLPENDING", 2);
    foreach($recs as $t => $v)
    {
        if($t == 'offset') continue;
        if($recs[$t][13] == 1)
        {
        $tmpStartTime = formatConflictTime($recs[$t][11]);
        $tmpEndTime = formatConflictTime($recs[$t][12]);
        if($tmpEndTime >= $starttime && $tmpStartTime < $endtime && $recs[$t][4] != $chanid)
           {
               $theQuery = "INSERT INTO conflictresolutionsingle (preferchanid,preferstarttime,preferendtime,dislikechanid,dislikestarttime,dislikeendtime) VALUES ('$chanid','$starttime','$endtime','" . $recs[$t][4] . "','$tmpStartTime','$tmpEndTime')";
               $result = mysql_query($theQuery);
           }
        }
    }	
}

function formatConflictTime($theTime) {
    $theTime = explode(" ",$theTime);
    $theTime = date("YmdHis",strtotime("$theTime[0], $theTime[1] $theTime[2] $theTime[4] $theTime[3]","\n"));
    return $theTime;
}

?>
